<template>
  <div>
    <div class="zone-list">
      <CCard>
        <CCardHeader>
          <div>
            <font-awesome-icon :icon="['fas', 'th']" />
            <strong>Zone list</strong>
          </div>
          <div class="card-header-actions">
            <CButton
              type="submit"
              color="primary"
              :variant="'ghost'"
              @click="onShowDetail(0)"
            >
              <font-awesome-icon :icon="['fas', 'plus-circle']" class="width-1x" />
              Add Zone
            </CButton>
          </div>
        </CCardHeader>

        <CCardBody>
          <ul class="row list">
            <li
              v-for="zone in zoneList"
              :key="zone.id"
              class="col-12 col-sm-6 col-md-4 col-xl-3 item"
            >
              <div class="list-group-item">
                <div class="txt-name">
                  <font-awesome-icon :icon="['fas', 'th']" class="width-1x" />
                  {{ zone.name }}
                </div>
                <ul class="row no-gutters box-detail">
                  <li class="col-6">
                    <CBadge :color="`${zone.status === 1 ? 'primary' : 'secondary'}`">
                      {{ zone.status === 1 ? 'ON' : 'OFF' }}
                    </CBadge>
                  </li>
                  <!-- <li class="col-4">
                    <font-awesome-icon :icon="['fas', 'check-circle']" class="width-1x" />
                    <span> 00 Things</span>
                  </li> -->
                  <li class="col-6 text-right">
                    <CSwitch
                      :id="zone.id"
                      :checked="zone.status === 1"
                      color="primary"
                      variant="3d"
                      shape="pill"
                      label-on="On"
                      label-off="Off"
                      @update:checked="onChangeStatusZone"
                    />
                  </li>
                </ul>
                <ul class="btns-action">
                  <li>
                    <div class="btn text-primary" @click="onShowDetail(zone.id)">
                      <font-awesome-icon :icon="['fas', 'pencil-alt']" />
                    </div>
                  </li>
                  <li>
                    <div class="btn text-danger" @click="onConfirmDelete(zone.id)">
                      <font-awesome-icon :icon="['fas', 'trash-alt']" />
                    </div>
                  </li>
                </ul>
              </div>
            </li>
          </ul>
        </CCardBody>
      </CCard>
    </div>

    <app-delete-confirm-dialog
      ref="deleteConfirmDialog"
      :name="'group'"
      @confirm="onDelete"
    />

    <zone-detail-modal
      :id="selectedId"
      ref="zoneDetailModal"
      @modify="getZoneList"
    />
  </div>
</template>

<style lang="scss" scoped>
  .zone-list {
    /deep/ {
      .list {
        margin: 0 -4px;
      }
      .item {
        padding: 0 4px;
        @include mq(xxl) {
          flex: 0 0 20%;
          max-width: 20%;
        }
      }
      .card-header {
        font-weight: bold;
      }
      .list-group-item {
        position: relative;
        background: #fff;
        border: 1px solid rgba(0, 0, 21, 0.125);
        border-radius: 5px;
        padding: 6px;
        margin-bottom: 10px;
        &:hover {
          .btns-action {
            opacity: 1;
          }
        }
        .txt-name {
          word-break: break-all;
          white-space: normal;
          font-weight: 500;
          padding-right: 43px;
          margin-bottom: 5px;
        }
        .box-detail {
          .c-switch{
            display: inline-block;
            vertical-align: middle;
          }
        }
        .btns-action {
          opacity: 0;
          display: block;
          position: absolute;
          right: 4px;
          top: 4px;
          white-space: nowrap;
          transition: all 0.4s ease;
          li {
            display: inline-block;
            vertical-align: middle;
          }
          .btn {
            width: 18px;
            height: 18px;
            font-size: 12px;
            background: none;
            border: 0;
            border-radius: 2px;
            outline: 0;
            text-align: center;
            padding: 0;
            margin: 0;
          }
        }
      }
    }
  }
</style>

<script>
import AppDeleteConfirmDialog from '~/components/molecules/AppDeleteConfirmDialog'
import ZoneDetailModal from '~/components/organisms/zones/ZoneDetailModal'

export default {
  components: {
    AppDeleteConfirmDialog,
    ZoneDetailModal
  },

  data () {
    return {
      resourceTypeName: 'zone',
      zoneList: [],
      selectedId: null
    }
  },

  mounted () {
    this.getZoneList()
  },

  methods: {
    /**
     * Call API get groups
     */
    getZoneList () {
      this.$dam.getZoneList()
        .then((res) => {
          if (Array.isArray(res.data) && res.data.length) {
            this.zoneList = res.data
          }
        })
        .catch((err) => {
          console.error(err)

          this.$toast.error(
            this.$text.error('FAILED_TO_GET', { name: 'zone list' })
          )
        })
    },

    /**
     * Event when change status of zone
     *
     * @return {Boolean} val - True if checkbox is checked, else false
     * @return {Object} event - Event object of checkbox
     */
    onChangeStatusZone (val, event) {
      if (!event.target.id) {
        return
      }

      const params = {
        id: +event.target.id,
        status: (val === true ? 1 : 0)
      }
      this.$dam.updateZone(params)
        .then((res) => {
          if (res && res.data && res.data.id) {
            // Change label state of current zone on page
            this.zoneList.map((zone) => {
              if (zone.id === res.data.id) {
                zone.status = (val === true ? 1 : 0)
                return zone
              }
            })

            this.$toast.success(
              this.$text.info('UPDATED', { name: this.resourceTypeName })
            )
          }
        })
        .catch((err) => {
          console.error(err)

          this.$toast.error(
            this.$text.error('FAILED_TO_UPDATE', { name: this.resourceTypeName })
          )

          this.getZoneList()
        })
    },

    /**
     * Open zone detail modal
     *
     * @param {Object} zone - Current zone
     */
    onShowDetail (id) {
      this.setSelectedId(id)
      this.$refs.zoneDetailModal.open()
    },

    /**
     * Open confirm delete
     * If confirm then call delete group
     * Else cancel
     *
     * @param {String} id - group id
     */
    onConfirmDelete (id) {
      this.setSelectedId(id)
      this.$refs.deleteConfirmDialog.open()
    },

    /**
     * After the deletion confirmation dialog is confirmed
     */
    onDelete () {
      if (this.selectedId) {
        this.$dam.deleteZone({ id: this.selectedId })
          .then((_) => {
            this.$toast.success(
              this.$text.info('DELETED', { name: this.resourceTypeName })
            )

            this.getZoneList()
          })
          .catch((err) => {
            console.error(err)

            this.$toast.error(
              this.$text.error('FAILED_TO_DELETE', { name: this.resourceTypeName })
            )
          })
      }
    },

    /**
     * Set select id
     *
     * @param {Number} id - Zone id
     */
    setSelectedId (id) {
      this.selectedId = id
    }
  }
}
</script>
